import * as React from 'react'
import {Icon, tokens} from '../src'

export default {
  title: 'Components/Icon',
  component: Icon,
  argTypes: {
    color: {
      control: {
        type: 'select',
        options: Object.keys(tokens.color),
      },
    },
    width: {
      control: {
        type: 'text',
      },
    },
    height: {
      control: {
        type: 'text',
      },
    },
    size: {
      control: {
        type: 'text',
      },
    },
  },
}

const Template = (props: any = {}) => (
  <span>
    Check out this inline <Icon {...props} /> icon
  </span>
)

export const Example = Template.bind({})
// @ts-ignore
Example.args = {
  size: '1em',
  'aria-label': 'book',
  render: Book,
}

function Book(props) {
  return (
    <svg fill='currentColor' viewBox='0 0 20 20' {...props}>
      <path d='M9 4.804A7.968 7.968 0 005.5 4c-1.255 0-2.443.29-3.5.804v10A7.969 7.969 0 015.5 14c1.669 0 3.218.51 4.5 1.385A7.962 7.962 0 0114.5 14c1.255 0 2.443.29 3.5.804v-10A7.968 7.968 0 0014.5 4c-1.255 0-2.443.29-3.5.804V12a1 1 0 11-2 0V4.804z'></path>
    </svg>
  )
}
